SystemOrganization addCategory: #'Xtreams-HttpTests'!

TestCase subclass: #XTChunkingReadStreamTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xtreams-HttpTests'!

!XTChunkingReadStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/12/2011 16:00'!
testGrowing
	| actual stream |
	stream :=  #[51 13 10 97 98 99 13 10 53 13 10 100 101 102 103 104 13 10 48 13 10 13 10]
		reading chunking.
	actual := stream read: 8.
	self assert: actual = #[97 98 99 100 101 102 103 104]! !

!XTChunkingReadStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/12/2011 16:30'!
testHexLengths
	
	| actual stream |
	stream :=  #[70 13 10 97 98 99 100 101 102 103 104 105 
				  106 107 108 109 110 111 13 10 48 13 10 13 10] reading chunking.
	actual := stream rest.
	self assert: actual = #[97 98 99 100 101 102 103 104 105 106 107 108 109 110 111]! !

!XTChunkingReadStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/12/2011 16:10'!
testPartialChunk
	| actual stream |
	stream :=  #[51 13 10 97 98 99 13 10 50 13 10 100 101 13 10 48 13 10 13 10]
		reading chunking.
	stream read: 2.
	actual := stream read: 3.
	self assert: actual = #[99 100 101]! !

!XTChunkingReadStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/12/2011 16:09'!
testRest
	| actual stream |
	stream :=  #[51 13 10 97 98 99 13 10 50 13 10 100 101 13 10 48 13 10 13 10]
		reading chunking.
	actual := stream rest.
	self assert: actual = #[97 98 99 100 101]! !

!XTChunkingReadStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/12/2011 16:02'!
testShrinking
	| actual stream |
	stream :=  #[51 13 10 97 98 99 13 10 50 13 10 100 101 13 10 48 13 10 13 10]
		reading chunking.
	actual := stream read: 5.
	self assert: actual = #[97 98 99 100 101]! !

TestCase subclass: #XTChunkingWriteStreamTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xtreams-HttpTests'!

!XTChunkingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/2/2011 18:42'!
chunk: aString
	| text |
	text := String new writing
		write: (aString size printStringBase: 16);
		cr;
		lf;
		write: aString;
		cr;
		lf;
		conclusion.
	^ text asByteArray! !

!XTChunkingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/2/2011 18:48'!
last: aString
	^ (self chunk: aString) , (self chunk: '')! !

!XTChunkingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/2/2011 21:22'!
testClose
	| compare stream |
	compare := (self last: 'abcdef') reading.
	stream := [ :byte | self assert: byte = compare get ] writing chunking.
	stream
		write: 'abc' asByteArray;
		write: 'def' asByteArray;
		close.
	self should: [ compare get ] raise: Incomplete! !

!XTChunkingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/17/2011 22:15'!
testHexLengths
	| compare stream |
	compare := (self chunk: 'abcdefghijklmno') reading.
	stream := [:ch | self assert: ch = compare get] writing chunking.
	stream 
		write: 'abcdefghijklmno';
		flush.
	self should: [compare get] raise: Incomplete.
	! !

!XTChunkingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/16/2011 09:27'!
testMultipleWrites
	| compare stream |
	compare := (self chunk: 'abcdef') reading.
	stream := [:ch | self assert: ch = compare get] writing chunking.
	stream 
		write: 'abc';
		write: 'def';
		flush.
	self should: [compare get] raise: Incomplete.
	! !

!XTChunkingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/2/2011 23:37'!
testOverflow
	| compare stream |
	compare := (self chunk: 'abcdef') reading.
	stream := [:byte | self assert: byte = compare get] writing chunking.
	stream bufferSize: 6.
	stream 
		write: 'abc';
		write: 'defghi'.
	self should: [compare get] raise: Incomplete.
	compare := (self chunk: 'ghi') reading.
	stream flush.
	self should: [compare get] raise: Incomplete.! !

!XTChunkingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/16/2011 01:07'!
testShortChunk
	| compare stream |
	compare := (self chunk: 'abc') reading.
	stream := [:ch | self assert: ch = compare get] writing chunking.
	stream 
		write: 'abc';
		flush.
	self should: [compare get] raise: Incomplete.
	! !

TestCase subclass: #XTUrlDecodingReadStreamTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xtreams-HttpTests'!

!XTUrlDecodingReadStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/19/2011 14:17'!
assert: encoded decodesTo: expected
	| actual in |
	in := encoded reading urldecoding.
	actual := in rest.
	self assert: actual = expected! !

!XTUrlDecodingReadStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/19/2011 14:20'!
testEncoded
	self 
		assert: '%61%62%63'
		decodesTo: 'abc'
	! !

!XTUrlDecodingReadStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/19/2011 15:03'!
testPercent
	self 
		assert: '%25'
		decodesTo: '%'
! !

!XTUrlDecodingReadStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/19/2011 14:16'!
testUnencodedCharacters
	| letters |
	letters := 'abcdefghijklmnopqrstuvwxyz'.
	self 
		assert: letters
		decodesTo: letters
	! !

TestCase subclass: #XTUrlEncodingWriteStreamTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xtreams-HttpTests'!

!XTUrlEncodingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/18/2011 15:10'!
assert: ch isEncoded: encoded
	| out actual |
	out := String new writing urlencoding.
	out put: ch.
	actual := out conclusion.
	self assert: actual first = $%.
	self assert: actual allButFirst = encoded! !

!XTUrlEncodingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/18/2011 13:58'!
assertIdentity: expected
	| out actual |
	out := String new writing urlencoding.
	out write: expected.
	actual := out conclusion.
	self assert: actual = expected! !

!XTUrlEncodingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/18/2011 15:17'!
testAmperstand
	self assert: $& isEncoded: '26'! !

!XTUrlEncodingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/18/2011 15:20'!
testAsterisk
	self assert: $* isEncoded: '2A'! !

!XTUrlEncodingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/18/2011 15:14'!
testBang
	self assert: $!!  isEncoded: '21'! !

!XTUrlEncodingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/18/2011 15:10'!
testColon
	self assert: $: isEncoded: '3A'! !

!XTUrlEncodingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/18/2011 15:21'!
testComma
	self assert: $, isEncoded: '2C'! !

!XTUrlEncodingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/18/2011 13:58'!
testDigits
	self assertIdentity: '0123456789'! !

!XTUrlEncodingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/18/2011 15:17'!
testDollar
	self assert: $$  isEncoded: '24'! !

!XTUrlEncodingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/18/2011 15:21'!
testEquals
	self assert: $= isEncoded: '3D'! !

!XTUrlEncodingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/18/2011 15:12'!
testHashMark
	self assert: $# isEncoded: '23'! !

!XTUrlEncodingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/18/2011 15:12'!
testLeftBracket
	self assert: $[ isEncoded: '5B'! !

!XTUrlEncodingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/18/2011 15:19'!
testLeftParen
	self assert: $( isEncoded: '28'! !

!XTUrlEncodingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/18/2011 13:59'!
testLowercase
	self assertIdentity: 'abcdefghijklmnopqrstuvwxyz'! !

!XTUrlEncodingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/18/2011 15:20'!
testPlus
	self assert: $+ isEncoded: '2B'! !

!XTUrlEncodingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/18/2011 15:11'!
testQuestionMark
	self assert: $? isEncoded: '3F'! !

!XTUrlEncodingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/18/2011 15:13'!
testRightBracket
	self assert: $@ isEncoded: '40'! !

!XTUrlEncodingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/18/2011 15:20'!
testRightParen
	self assert: $) isEncoded: '29'! !

!XTUrlEncodingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/18/2011 15:21'!
testSemicolon
	self assert: $; isEncoded: '3B'! !

!XTUrlEncodingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/18/2011 15:18'!
testSingleQuote
	self assert: $' isEncoded: '27'! !

!XTUrlEncodingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/18/2011 15:11'!
testSlash
	self assert: $/ isEncoded: '2F'! !

!XTUrlEncodingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/18/2011 13:59'!
testUnreservedPunctuation
	self assertIdentity: '-._~'! !

!XTUrlEncodingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/18/2011 13:59'!
testUppercase
	self assertIdentity: 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'! !
